package main

import (
	"fmt"

	"git.dummkopf.live/InventorX/pinwindows"
	gui "github.com/gen2brain/raylib-go/raygui"
	rl "github.com/gen2brain/raylib-go/raylib"
)

const RENDERWIDTH = 1280
const RENDERHEIGHT = 720

const SCREENWIDTH = 1280
const SCREENHEIGHT = 720

const WIDTHSCALE float32 = RENDERWIDTH / float32(SCREENWIDTH)
const HEIGHTSCALE float32 = RENDERHEIGHT / float32(SCREENHEIGHT)

type bsp_node struct {
	front *bsp_node
	back  *bsp_node
	wall  wall
}

type wall struct {
	v1        rl.Vector2
	v2        rl.Vector2
	direction rl.Vector2
}

func UpdateRenderTexture(texture *rl.RenderTexture2D) {
	if rl.IsWindowResized() {
		rl.UnloadRenderTexture(*texture)
		*texture = rl.LoadRenderTexture(int32(rl.GetScreenWidth()), int32(rl.GetScreenHeight()))
	}
}

func (w wall) Draw() {
	rl.DrawLineV(w.v1, w.v2, rl.White)
	midpoint := rl.Vector2MoveTowards(w.v1, w.v2, rl.Vector2Distance(w.v1, w.v2)/2)
	slopevec := rl.Vector2Subtract(w.v2, w.v1)
	perpslope := rl.Vector2{X: slopevec.Y, Y: -slopevec.X}
	perpslopeNormalized := rl.Vector2Normalize(perpslope)
	rl.DrawLineV(midpoint, rl.Vector2Add(rl.Vector2Scale(perpslopeNormalized, 20), midpoint), rl.Red)
}

func main() {
	fmt.Println("test")
	rl.InitWindow(SCREENWIDTH, SCREENHEIGHT, "raylib [core] example - basic window")
	rl.SetWindowState(rl.FlagWindowResizable)
	defer rl.CloseWindow()

	rl.SetTargetFPS(int32(rl.GetMonitorRefreshRate(0)))
	a := rl.GetMonitorPosition(0)
	mh := rl.GetMonitorHeight(0)
	mw := rl.GetMonitorWidth(0)
	rl.SetWindowPosition(int(a.X)+int(0.5*float32(mw))-(SCREENWIDTH/2), int(a.Y)+int(0.5*float32(mh))-(0.5*SCREENHEIGHT))

	rendertexture := rl.LoadRenderTexture(RENDERWIDTH, RENDERHEIGHT)
	rl.SetTextureFilter(rendertexture.Texture, rl.FilterTrilinear)
	var frametime float32 = 0
	walltest := wall{rl.Vector2{X: 50, Y: 50}, rl.Vector2{X: 100, Y: 100}, rl.Vector2{X: 50, Y: 50}}

	var MapOrigWalls []wall
	MapOrigWalls = append(MapOrigWalls, walltest)

	mainwindowmanager := pinwindows.NewRayGuiWindowManager()
	raywin := pinwindows.NewRayGuiWindow(100, 100, 200, 200)
	mainwindowmanager.AddWindow(&raywin)

	for !rl.WindowShouldClose() {

		mainwindowmanager.ManageWindowlist()
		mainwindowmanager.ProcessUserWindowMovement()

		raywin.BeginDrawMode()
		rl.ClearBackground(rl.White)
		rl.DrawText("erm", 0, 0, 012, rl.Black)
		raywin.EndDrawMode()

		frametime = rl.GetFrameTime()
		UpdateRenderTexture(&rendertexture)

		mainwindowmanager.DrawInternalWindowList()

		//camera.Target = rl.Vector2{0, 0}
		rl.BeginTextureMode(rendertexture)
		rl.ClearBackground(rl.Black)

		mainwindowmanager.DrawWindowlist()

		//rl.EndMode2D()
		//draw Scaled UI (buttons wont work here)

		rl.DrawText(fmt.Sprintf("%f", frametime), 0, 0, 22, rl.Black)

		walltest.Draw()
		rl.DrawCircle(int32(rl.GetMousePosition().X), int32(rl.GetMousePosition().Y), 10, rl.Blue)
		rl.EndTextureMode()

		rl.BeginDrawing()

		rl.DrawTexturePro(rendertexture.Texture, rl.NewRectangle(0, 0, float32(rendertexture.Texture.Width), -float32(rendertexture.Texture.Height)), rl.NewRectangle(0, 0, float32(rl.GetScreenWidth()), float32(rl.GetScreenHeight())), rl.NewVector2(0, 0), 0, rl.White)
		gui.Button(rl.NewRectangle(1000, 600, 50, 50), "erm")
		var sind int32 = 0
		gui.ListView(rl.NewRectangle(0, 0, 100, 500), "test\n,; test", &sind, 0)
		//Absoulte drawing
		rl.EndDrawing()
	}
}
